Attribute VB_Name = "mDlg"
Option Explicit
Private Const MAX_PATH = 260
Private Const MAX_FILE = 260

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Private Declare Function GetOpenFileName Lib "COMDLG32" Alias "GetOpenFileNameA" (file As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "COMDLG32" Alias "GetSaveFileNameA" (file As OPENFILENAME) As Long

Public Enum EOpenFile
    OFN_READONLY = &H1
    OFN_OVERWRITEPROMPT = &H2
    OFN_HIDEREADONLY = &H4
    OFN_NOCHANGEDIR = &H8
    OFN_SHOWHELP = &H10
    OFN_ENABLEHOOK = &H20
    OFN_ENABLETEMPLATE = &H40
    OFN_ENABLETEMPLATEHANDLE = &H80
    OFN_NOVALIDATE = &H100
    OFN_ALLOWMULTISELECT = &H200
    OFN_EXTENSIONDIFFERENT = &H400
    OFN_PATHMUSTEXIST = &H800
    OFN_FILEMUSTEXIST = &H1000
    OFN_CREATEPROMPT = &H2000
    OFN_SHAREAWARE = &H4000
    OFN_NOREADONLYRETURN = &H8000
    OFN_NOTESTFILECREATE = &H10000
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOLONGNAMES = &H40000
    OFN_EXPLORER = &H80000
    OFN_NODEREFERENCELINKS = &H100000
    OFN_LONGNAMES = &H200000
End Enum
Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


' Messages:
Private Const WM_DESTROY = &H2
Private Const WM_NOTIFY = &H4E
Private Const WM_NCDESTROY = &H82
Private Const WM_GETDLGCODE = &H87
Private Const WM_INITDIALOG = &H110
Private Const WM_COMMAND = &H111
Private Const WM_USER = &H400


' Messages to dialog controls
Private Const CDM_FIRST = (WM_USER + 100)
Private Const CDM_LAST = (WM_USER + 200)

Private Const CDM_GETSPEC = (CDM_FIRST + &H0)
Private Const CDM_GETFILEPATH = (CDM_FIRST + &H1)
Private Const CDM_GETFOLDERPATH = (CDM_FIRST + &H2)
Private Const CDM_GETFOLDERIDLIST = (CDM_FIRST + &H3)
Private Const CDM_SETCONTROLTEXT = (CDM_FIRST + &H4)
Private Const CDM_HIDECONTROL = (CDM_FIRST + &H5)
Private Const CDM_SETDEFEXT = (CDM_FIRST + &H6)

' Dialog controls IDs
Private Const ID_OPEN = &H1  'Open or Save button
Private Const ID_CANCEL = &H2 'Cancel Button
Private Const ID_HELP = &H40E 'Help Button
Private Const ID_READONLY = &H410 'Read-only check box
Private Const ID_FILETYPELABEL = &H441 'FileType label
Private Const ID_FILELABEL = &H442 'FileName label
Private Const ID_FOLDERLABEL = &H443 'Folder label
Private Const ID_FORMAT = &H470 'FileType combo box
Private Const ID_FOLDER = &H471 'Folder combo box
Private Const ID_FILETEXT = &H480 'FileName text box

Private Const SW_NORMAL = 1

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Dim OFN As OPENFILENAME
Dim rct As RECT
Public hDlg As Long
Public DlgFlags As EOpenFile
Public DlgLeft As Long, DlgTop As Long
Public DlgOpenVisible As Boolean, DlgCancelVisible As Boolean
Public DlgOpenText As String, DlgCancelText As String

Private Function lHookAddress(lPtr As Long) As Long
  lHookAddress = lPtr
End Function

Public Function DialogHookFunction(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case wMsg
          Case WM_INITDIALOG
               MoveDlg hDlg
               ModifyDlg hDlg
          Case Else
   End Select
End Function
Public Sub InitOFN(Optional ByVal hOwner As Long)
   With OFN
       .hwndOwner = hOwner
       .lpfnHook = lHookAddress(AddressOf DialogHookFunction)
       .flags = DlgFlags
       .lStructSize = LenB(OFN)
   End With
End Sub

Public Sub ShowSave()
   hDlg = GetOpenFileName(OFN)
End Sub

Public Sub ShowOpen()
   hDlg = GetOpenFileName(OFN)
End Sub

Private Sub MoveDlg(hDlg)
  Dim DlgHwnd As Long
  DlgHwnd = GetParent(hDlg)
  'DlgHwnd = hdlg 'When using with other then Open/Save Dialogs
  GetWindowRect DlgHwnd, rct
  MoveWindow DlgHwnd, DlgLeft, DlgTop, rct.Right - rct.Left, rct.Bottom - rct.Top, 1
End Sub

Private Sub ModifyDlg(hDlg)
  Dim DlgHwnd As Long
  DlgHwnd = GetParent(hDlg)
  SendMessage DlgHwnd, CDM_SETCONTROLTEXT, ID_OPEN, ByVal DlgOpenText
  SendMessage DlgHwnd, CDM_SETCONTROLTEXT, ID_CANCEL, ByVal DlgCancelText
  SendMessage DlgHwnd, CDM_HIDECONTROL, ID_FILETEXT, 0&
End Sub
